unit Unit1;

{$mode objfpc}{$H+}

interface

uses
  Classes, SysUtils, Forms, Controls, Graphics, Dialogs, StdCtrls;

type

  { TForm1 }

  TTestrecord = record
     i64 : int64;
     i32 : integer;
     i16 : smallint;
     i8  : shortint;
     f   : single;
     d   : double;
     end;
  TForm1 = class(TForm)
    Button1: TButton;
    procedure Button1Click(Sender: TObject);
  private

  public
    rm : TTestrecord;

  end;

  Tlibfunc = function : integer;

var
  tmclib       : TLibHandle;      // handle to libtmc
  Form1: TForm1;
  libfunc : Tlibfunc;
  mr : TTestrecord;
  //function libfunc: integer cdecl;external '..\dummylib\libfunction.dll';

implementation

{$R *.lfm}

{ TForm1 }

procedure TForm1.Button1Click(Sender: TObject);
var
  libresult : integer;
begin
  mr.i64 := 64;
  mr.i32 := 32;
  mr.i16 := 16;
  mr.i8 :=   8;
  mr.f  := 3.14;
  mr.d  := 3.14159;
  rm := mr;
  libresult := libfunc();
  showmessage('libfunc returned ' + inttostr(libresult));
end;

procedure myerror(name : string);
begin
  showmessage('routine ' + name + ' not found in dll');
end;

initialization
tmclib := LoadLibrary('..\dummylib\libfunction.dll');
if tmclib = 0 then
  showmessage('lib not found');
libfunc:= Tlibfunc(  getProcAddress(tmclib,'libfunc'));  if libfunc= nil then myerror('libfunc');

end.


